from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String

Removepseudoknots_Smp_V0_1_0 = CommandToolBuilder(tool="RemovePseudoknots_smp", base_command=["RemovePseudoknots-smp"], inputs=[ToolInput(tag="in_dna", input_type=Boolean(optional=True), prefix="--DNA", doc=InputDocumentation(doc="Specify that the sequence is DNA, and DNA parameters are to be used.\nDefault is to use RNA parameters.")), ToolInput(tag="in_bracket", input_type=Boolean(optional=True), prefix="--bracket", doc=InputDocumentation(doc="Write the output as a dot-bracket file instead of a CT file. (Note that the\ninput file can be either a CT or bracket file, regardless of this option.)")), ToolInput(tag="in_maximize", input_type=Boolean(optional=True), prefix="--maximize", doc=InputDocumentation(doc="Specify that the NUMBER of remaining base pairs should be maximized in the\npseudoknot-free structure in an energy-agnostic way -- i.e. with no regard\nfor the folding free energy of the structure.\nThis is usually much faster than the default behavior, which is to break\nbase-pairs such that the final structure(s) have minimum free energy.\nThe default method often maximizes the number of remaining base pairs, but\nnot always.")), ToolInput(tag="in_me_a", input_type=Boolean(optional=True), prefix="--MEA", doc=InputDocumentation(doc="Use the MaxExpect method (MEAFill) to break pseudoknots. This should\nproduce identical results as the 'maximize' option (-m), but will be slower\n(for testing only).")), ToolInput(tag="in_quiet", input_type=File(optional=True), prefix="--quiet", doc=InputDocumentation(doc="Suppress unnecessary output. This option is implied when the output file is\n'-' (STDOUT).")), ToolInput(tag="in_temperature", input_type=Boolean(optional=True), prefix="--temperature", doc=InputDocumentation(doc="Specify the temperature at which calculation takes place in Kelvin.\nDefault is 310.15 K, which is 37 degrees C.\n")), ToolInput(tag="in_remove_pseudo_knots", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_input_ct_file", input_type=File(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_output_ct_file", input_type=File(), position=2, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_quiet", output_type=File(optional=True), selector=InputSelector(input_to_select="in_quiet", type_hint=File()), doc=OutputDocumentation(doc="Suppress unnecessary output. This option is implied when the output file is\n'-' (STDOUT).")), ToolOutput(tag="out_output_ct_file", output_type=File(), selector=InputSelector(input_to_select="in_output_ct_file", type_hint=File()), doc=OutputDocumentation(doc=""))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Removepseudoknots_Smp_V0_1_0().translate("wdl", allow_empty_container=True)

